Subject: Re: linux-next: Crash in arm_pmu_device_probe() due to 'drivers/perf: arm_pmu: make info messages more verbose'

From: Guenter Roeck <[email-masked]>
Date: Fri, 18 Mar 2016 06:30:25 -0700

Hi Dirk,

On 03/18/2016 02:18 AM, Dirk Behme wrote:
> Hi Guenter,
>
> On 18.03.2016 07:44, Guenter Roeck wrote:
>> Hi,
>>
>> I am seeing the attached crash when running a realview-pb-a8 image with
>> realview_defconfig in qemu.
>> bisect wasn't successful, but a commit analysis identified commit
>> 'drivers/perf: arm_pmu: make info
>> messages more verbose' as the culprit. Reverting this commit fixes the
>> problem.
>>
>> The code roughly looks as follows.
>>
>> int arm_pmu_device_probe()
>> {
>>      ...
>>      if (node && ..) {
>>      } else {
>>      }
>>
>>      if (ret) {
>>                  pr_info("%s: failed to probe PMU! Error %i\n",
>>                          node->full_name, ret);
>>                  goto out_free;
>>      }
>>      ....
>> out_free:
>>      pr_info("%s: failed to register PMU devices! Error %i\n",
>>                  node->full_name, ret);
>>      ....
>> }
>>
>> Note that 'node' is dereferenced even though it was previously checked
>> if it is NULL.
>> The configuration I am testing does not use devicetree.
>>
>> Can you use dev_info() instead ?
>
>
> Does anything like below [1] does work for you?
>
> If so, could you please share the output? I.e. what it prints in your non-devicetree non-pmu case?
>
This is what I get:

hw perfevents: probing PMU on CPU 0
armv7-pmu armv7-pmu: failed to probe PMU! Error -6
armv7-pmu armv7-pmu: failed to register PMU devices! Error -6

Another option might be to use of_node_full_name() (or even better
both dev_info() and of_node_full_name()).

Not sure though what you are looking for. '/soc/pmu_a53' doesn't
tell (me) much either, and I am not sure I understand the context
of the bug description. Why would the kernel try to initialize PMU
for a CPU which isn't online ? And if it really does, wouldn't it make
more sense to print CPU number and CPU ID instead of a devicetree
node name ?

Thanks,
Guenter

> Best regards
>
> Dirk
>
> [1]
>
> diff --git a/drivers/perf/arm_pmu.c b/drivers/perf/arm_pmu.c
> index 11bacc7..bda3502 100644
> --- a/drivers/perf/arm_pmu.c
> +++ b/drivers/perf/arm_pmu.c
> @@ -1002,8 +1002,7 @@ int arm_pmu_device_probe(struct platform_device *pdev,
>         }
>
>         if (ret) {
> -               pr_info("%s: failed to probe PMU! Error %i\n",
> -                       node->full_name, ret);
> +               dev_info(&pdev->dev, "failed to probe PMU! Error %i\n", ret);
>                 goto out_free;
>         }
>
> @@ -1023,8 +1022,7 @@ int arm_pmu_device_probe(struct platform_device *pdev,
>  out_destroy:
>         cpu_pmu_destroy(pmu);
>  out_free:
> -       pr_info("%s: failed to register PMU devices! Error %i\n",
> -               node->full_name, ret);
> +       dev_info(&pdev->dev, "failed to register PMU devices! Error %i\n", ret);
>         kfree(pmu);
>         return ret;
>  }
>
>